<template>
  <AppAbstractPage
    class="requestToSpare"
    :breadcrumbs="breadcrumbs">
    <div
      slot="heading"
      class="pageHeading">
      <div class="pageHeading-basic">
        <h1 class="heading _h1">
          {{ pageH1 }}
        </h1>
        <h2 class="heading _h2">
          {{ pageH2 }}
        </h2>
      </div>
    </div>
    <div
      slot="content"
      class="requestToSpare-content">
      <!-- @TODO Refactoring убрать сообщения валидации из шаблона -->
      <form
        v-if="!complete"
        class="form"
        :class="{ '_has-error': validation.hasError() }"
        novalidate="validate"
        autocomplete="off"
        @submit.prevent="send">
        <h4 class="form-title">Какой у вас автомобиль?</h4>
        <div class="form-group">
          <div class="form-group-car">
            <!-- Марка автомобиля * v -->
            <div class="form-item _car">
              <div
                v-show="validation.hasError('manufacturer')"
                class="input-message-error">Заполните марку авто
              </div>
              <AppSelect
                v-model="manufacturer"
                :class="{'-invalid': validation.hasError('manufacturer')}"
                :placeholder="'Марка автомобиля *'"
                :options="manufacturerValues"/>
            </div>

            <!-- Модель автомобиля * -->
            <div class="form-item _car">
              <div
                v-show="validation.hasError('model')"
                class="input-message-error">Заполните модель авто
              </div>
              <AppSelect
                v-model="model"
                :disabled="!manufacturer"
                :placeholder="'Модель автомобиля *'"
                :class="{'-invalid': validation.hasError('model')}"
                :options="modelValues"/>
            </div>

            <!-- Год выпуска * v -->
            <div class="form-item _car-year">
              <div
                v-show="validation.hasError('year')"
                class="input-message-error">Заполните год выпуска
              </div>
              <InputPartYear
                v-model="year"
                :classes="{'-invalid': validation.hasError('year')}"
                :years-range="yearsRange"/>
              <select-native
                v-model="year"
                :options="yearsRange"
                :classes="{'-invalid': validation.hasError('year')}"
                placeholder="Год выпуска *"/>
            </div>

            <!-- Кузов -->
            <div
              v-if="isBodyEngineShown"
              class="form-item _car">
              <div class="input">
                <input
                  maxlength="100"
                  v-model="body"
                  placeholder="Кузов"
                  class="input-field">
              </div>
            </div>

            <!-- Двигатель -->
            <div
              v-show="isBodyEngineShown"
              class="form-item _car">
              <div class="input">
                <input
                  maxlength="100"
                  v-model="engine"
                  class="input-field"
                  placeholder="Двигатель">
              </div>
            </div>

            <div class="form-item _bigger">
              <span
                @click="toggleBodyEngine"
                class="link linkShowSwitcher">
                {{ isBodyEngineShown ? 'Скрыть кузов и двигатель' : 'Кузов и двигатель' }}
              </span>
            </div>
          </div>

          <div class="form-group-vin">
            <!-- VIN -->
            <!-- validation.firstError('vin') -->
            <div class="form-item _bigger">
              <div
                v-show="validation.hasError('vin')"
                class="input-message-error">
                {{ validation.firstError('vin') }}
              </div>
              <div
                :class="{ '-invalid': validation.hasError('vin') }"
                class="input">
                <input
                  v-model="vin"
                  type="text"
                  class="input-field"
                  :maxlength="20"
                  placeholder="VIN или FRAME номер">
              </div>
            </div>
            <AppTooltipVinExample/>
          </div>
        </div>

        <h4 class="form-title">Какая запчасть вам нужна?</h4>
        <div
          v-for="(part, index) in parts"
          :key="index"
          class="form-group">
          <div class="form-group-part">
            <!-- Название запчасти * v -->
            <div class="form-item _part-name">
              <div
                v-show="validation.firstError('parts')
                  && validation.firstError('parts')[index]
                && validation.firstError('parts')[index]['partName']"
                class="input-message-error">Укажите нужную вам запчасть
              </div>
              <div class="wrapper">
                <InputPartName
                  :classes="{'-invalid': validation.firstError('parts')
                    && validation.firstError('parts')[index]
                  && validation.firstError('parts')[index]['partName'] }"
                  v-model="part.partName"/>
                <!-- Удалить запчасть в мобилке -->
                <button
                  v-show="index > 0 || parts.length > 1"
                  class="buttonTrash"
                  @click.prevent.stop="parts.splice(index, 1)">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/cross-bold-in-circle.svg">
                </button>
              </div>
            </div>
            <!-- Комментарий: любые пожелания к запросу -->
            <div
              v-show="part.partCommentShow"
              class="form-item _comment">
              <div class="input">
                <textarea
                  v-model="part.partVendorCode"
                  maxlength="255"
                  class="input-field _textarea"
                  placeholder="Комментарий: любые пожелания к запросу"/>
              </div>
            </div>

            <div class="form-item _bigger">
              <span
                @click="togglePartComment(index)"
                class="link linkShowSwitcher">
                {{ partCommentText(index) }}
              </span>
            </div>
          </div>

          <div class="form-group-type">
            <!-- Тип запчасти (радио: Любая/Новая/Контрактная (б/у)) -->
            <div class="form-item">
              <AppInputRadio
                :name="`partType${index}`"
                :list="partTypes"
                v-model="part.partCondition"/>
            </div>

            <!-- Количество -->
            <div class="form-item _counter">
              <AppInputNumber
                :value="part.partQuantity"
                @changeCount="partQuantityVal(index, $event)"/>
              <!-- Удалить запчасть в десктопе -->
              <button
                v-show="index > 0 || parts.length > 1"
                class="buttonTrash"
                @click.prevent.stop="parts.splice(index, 1)">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/cross.svg">
              </button>
            </div>
          </div>

          <div class="form-group-more">
            <div class="form-item">
              <!-- Еще запчасть -->
              <AppButton
                v-show="index === parts.length - 1"
                @click.native="parts.push({ ...ref.blankPart }); $ym('vinrequest_part_add')"
                :classes="['buttonMore', '_blue']">
                <div
                  slot="button-item"
                  class="button-item">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/plus.svg">
                  Еще запчасть
                </div>
              </AppButton>
            </div>
          </div>
        </div>

        <h4 class="form-title">Как с вами связаться?</h4>

        <div class="form-group">
          <!-- Выбор города -->
          <div class="form-item _contact">
            <div
              v-show="validation.hasError('user.city')"
              class="input-message-error">Укажите ваш город
            </div>
            <AppCitySearch
              v-model="user.city"
              :composite="false"
              :placeholder="'Город *'"
              :classes="{'-invalid': validation.hasError('user.city')}"/>
          </div>

          <!-- Имя -->
          <div class="form-item _contact">
            <div
              v-show="validation.hasError('user.name')"
              class="input-message-error">Укажите ваше имя
            </div>
            <div
              class="input"
              :class="{ '-invalid': validation.hasError('user.name') }">
              <input
                v-model="user.name"
                class="input-field"
                placeholder="Имя *">
            </div>
          </div>

          <!-- Телефон * -->
          <div class="form-item _contact">
            <AppInputPhone
              v-model="user.phone"
              :composite="false"
              :classes="{ '-invalid': validation.hasError('user.phone'), 'validate-top': true }"
              :options="{ 'validationRule': { isRequired: false } }"/>
          </div>

          <!-- E-mail * -->
          <div class="form-item _contact">
            <div
              v-show="validation.hasError('user.email')"
              class="input-message-error">Укажите ваш e-mail
            </div>
            <div
              v-show="!isUniqueEmail"
              class="input-message-error">Этот e-mail уже зарегистрирован, введите другой e-mail
            </div>
            <div
              class="input"
              :class="{ '-invalid': validation.hasError('user.email') }">
              <input
                class="input-field"
                placeholder="E-mail *"
                @input="isUniqueEmail = true"
                v-model="user.email">
            </div>
          </div>
        </div>

        <div
          v-if="!complete"
          class="form-group">
          <!-- Отправить запрос -->
          <div class="form-item _submit">
            <AppButton
              id="guide-send"
              type="submit"
              :disabled="validation.hasError()"
              :classes="['buttonSend']">
              <template #button-item>
                Отправить запрос
              </template>
            </AppButton>
          </div>
        </div>
      </form>

      <AppResponseInfo
        v-else
        :vin="vin"
        :body="body"
        :engine="engine"
        :response="requestResponse"
        :success="true"/>
    </div>
  </AppAbstractPage>
</template>

<script>
import SimpleVueValidation from 'simple-vue-validator';
import {
  isEmpty,
  find,
  get,
  set,
} from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';
import mapFilters from '~/assets/js/helpers/map-filters';
import { range } from '~/assets/js/funcs';
import { SHOW_AUTH_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import Multiselect from 'vue-multiselect';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';
import AppSelectComposite from '~/components/redesign/app-select/app-select-composite';
import AppSelect from '~/components/redesign/app-select/app-select';
import InputPartName from '~/components/redesign/app-input/app-input-part-name';
import InputPartYear from '~/components/redesign/app-input/app-input-part-year';
import AppInputNumber from '~/components/redesign/app-input/app-input-number';
import AppPopover from '~/components/redesign/app-tooltip/app-popover';
import AppCitySearch from '~/components/redesign/app-input/app-city-search';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import AppResponseInfo from '~/components/redesign/app-response-info';
import SelectNative from '~/components/redesign/app-select/app-select-native';
import AppTooltipVinExample from '~/components/redesign/app-tooltip/app-tooltip-vin-example';
import AppInputRadio from '~/components/redesign/app-input/app-input-radio';

// Mixins
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/request-to-spare';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail.',
  },
});

const blankPart = Object.freeze({
  partName: {
    id: null,
    name: null,
  },
  partVendorCode: null,
  partCondition: 37, // любая
  partQuantity: 1,
  partPhoto: null,
  partCommentShow: false,
});

export default {
  name: 'RequestToSpare',
  components: {
    AppInputRadio,
    AppTooltipVinExample,
    AppAbstractPage,
    AppButton,
    AppInputComposite,
    AppSelectComposite,
    AppSelect,
    Multiselect,
    InputPartName,
    InputPartYear,
    AppInputNumber,
    AppPopover,
    AppCitySearch,
    AppInputPhone,
    AppResponseInfo,
    SelectNative,
  },
  mixins: [SimpleVueValidation.mixin, SeoMixin, SeoPageMixin],

  async asyncData({ app, query }) {
    let resolvePartName = {};
    let manufacturerValues = [];
    let manufacturer = null;
    let model = null;
    let modelValues = [];

    try {
      ({ data: manufacturerValues } = await app.$axios.$get('/_main/carManufacturer/list', {
        params: { hasModels: 1 },
      }));

      if (query.partNameSlug) {
        ({ data: resolvePartName } = await app.$axios.$get('/_main/partItemName/getPartNameBySlug', {
          params: { partNameSlug: query.partNameSlug },
        }));
      }

      if (query.partNameId) {
        ({ data: resolvePartName } = await app.$axios.$get('/_main/partItemName/getPartNameById', {
          params: { partNameId: query.partNameId },
        }));
      } else if (query.partName) {
        resolvePartName = {
          id: null,
          name: query.partName,
        };
      }

      if (query.manufacturer) {
        manufacturer = find(manufacturerValues, item => item.slug === query.manufacturer);
        if (manufacturer && manufacturer.id) {
          ({ data: modelValues } = await app.$axios.$get('/_main/carModel/getByManufacturerId', {
            params: { manufacturerId: manufacturer.id },
          }));
        }
      }

      if (query.model) {
        model = find(modelValues, item => item.slug === query.model);
      }

      return {
        manufacturer,
        manufacturerValues,
        model,
        modelValues,
        resolvePartName,
        year: query.year || '',
        vin: query.vin || null,
      };
    } catch (e) {
      console.log(e);
    }

    return {
      manufacturer: null,
      model: null,
      manufacturerValues: [],
      year: query.year || '',
      vin: query.vin || null,
      modelValues: [],
    };
  },
  data() {
    return {
      loading: false,
      complete: false,
      popoverBaseClass: 'tooltip tooltipAddPrice',
      isUniqueEmail: true,
      requestResponse: {},
      yearsRange: range(1970, Number(new Date().getFullYear())).reverse(),
      partTypes: [
        {
          value: 37,
          label: 'Любая',
        },
        {
          value: 35,
          label: 'Новая',
        },
        {
          value: 36,
          label: 'Контрактная (б/у)',
        },
      ],
      parts: [{ ...blankPart }],
      body: null,
      engine: null,
      user: {
        name: null,
        phone: null,
        email: null,
        city: null,
      },
      ref: {
        blankPart,
      },
      isBodyEngineShown: false,
      firstTimeValidate: false,
      breadcrumbs: [
        {
          url: '',
          name: 'VIN-запрос',
        },
      ],
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    modelDisabled() {
      return isEmpty(this.manufacturer) || isEmpty(this.modelValues);
    },
    showSendError() {
      return this.validation.hasError()
        && this.validation.errors
          .filter(error => error.field !== 'vin')
          .filter(error => isEmpty(this.year) || error.field !== 'year')
          .filter(error => isEmpty(this.user.email) || error.field !== 'user.email')
          .length
        && (
          isEmpty(this.manufacturer)
          || isEmpty(this.model)
          || isEmpty(this.year)
          || isEmpty(this.user.name)
          || isEmpty(this.user.email)
          || isEmpty(this.user.city)
          || isEmpty(this.user.city.id)
          || this.validation.hasError('parts')
        );
    },
    pageH1() {
      const chooseWords = ['магазин', 'магазина', 'магазинов'];
      const sellerCounter = this.transChoose(this.requestResponse.sellerCounter, chooseWords)
        || [];

      return this.complete
        ? `Запрос на запчасти успешно отправлен в
        ${this.requestResponse.sellerCounter} ${sellerCounter}!`
        : 'VIN-запрос (Запрос на запчасти по данным автомобиля)';
    },
    pageH2() {
      return this.complete
        ? ''
        : 'Заполните данные и получите предложения автомагазинов';
    },
  },
  validators: {
    vin(value) {
      value = value ? value.replace(/ /g, '-') : '';
      return SimpleVueValidator.value(value).custom(() => {
        if (!SimpleVueValidator.isEmpty(value)) {
          if (value.length < 8 || value.length > 20) {
            return 'Некорректное количество символов <br> для VIN/FRAME номера';
          }

          if (!value.match(/[0-9]/i) || !value.match(/[a-hj-npr-z]/i)) {
            return 'Некорректные символы для VIN-номера,<br> проверьте введенный номер';
          }

          if (value.match(/[^0-9a-hj-npr-z]/i) && value.length === 17) {
            return 'Некорректные символы для VIN-номера,<br> проверьте введенный номер';
          }

          if (value.length !== 17 && (value.trim().indexOf('-') === -1)) {
            return 'Некорректный номер кузова: код и номер<br> кузова должны быть разделены пробелом'
              + '<br> или дефисом, например, WTP12-061548 или WTP12 061548';
          }
        }

        return false;
      });
    },
    manufacturer(value) {
      return SimpleVueValidator.value(value).custom(() => value === null || !value.id);
    },
    model(value) {
      return SimpleVueValidator.value(value).custom(() => value === null || !value.id);
    },
    year(value) {
      return SimpleVueValidator.value(value).required().custom(() => {
        if (value < 1900 || value > (new Date()).getFullYear()) {
          return 'Введите корректный год';
        }
        return false;
      });
    },
    parts(value) {
      return SimpleVueValidator.value(value).custom(() => {
        const errors = {};
        value.forEach((part, index) => {
          if (!part.partName || (!part.partName.id && !part.partName.name)) {
            set(errors, `${index}.partName`, true);
          }
          if (!part.partCondition) {
            set(errors, `${index}.partCondition`, true);
          }
        });
        return Object.keys(errors).length ? errors : false;
      });
    },
    'user.city'(value) {
      return SimpleVueValidator.value(value).required();
    },
    'user.name'(value) {
      return SimpleVueValidator.value(value).required();
    },
    'user.email'(value) {
      return SimpleVueValidator.value(value).required().email();
    },
  },
  watch: {
    async manufacturer(newValue) {
      this.model = null;
      this.modelValues = [];
      if (newValue && newValue.id) {
        try {
          this.modelValues = await this.$axios.$get('/_main/carModel/getByManufacturerId', {
            params: { manufacturerId: newValue.id },
          }).then(({ data }) => data);
        } catch (e) {
          console.error(e);
        }
      }
    },
    parts: {
      handler() {
        if (!this.firstTimeValidate) {
          this.firstTimeValidate = true;
        } else {
          this.$validate('parts');
        }
      },
      deep: true,
    },
  },
  created() {
    if (this.resolvePartName && this.resolvePartName.name) {
      this.parts.splice(0, 1, {
        ...blankPart,
        partName: {
          id: this.resolvePartName.id,
          name: this.resolvePartName.name,
        },
      });
    }

    if (!isEmpty(this.auth)) {
      this.user.email = this.auth.chatRole !== 'guest' ? get(this.auth, 'username', '') : '';
      this.user.phone = get(this.auth, 'userProfile.phone', '');
      this.user.name = get(this.auth, 'userProfile.firstName', '');
      const city = {
        id: get(this.auth, 'userProfile.city.id', 0),
        name: get(this.auth, 'userProfile.city.name', ''),
      };
      city.region = get(this.auth, 'userProfile.city.parent.name', '');
      this.user.city = city;
    }
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
    }),
    ...mapFilters(['transChoose']),
    async send() {
      const isValid = await this.$validate();

      if (!isValid) {
        return false;
      }

      this.loading = true;
      this.$axios.$post('/_main/vinRequest/createVinRequest', {
        vin: this.vin ? this.vin.trim() : '',
        carManufacturerId: this.manufacturer.id,
        carModelId: this.model.id,
        carBody: this.body,
        carEngine: this.engine,
        carReleaseYear: this.year,
        customerName: this.user.name,
        customerCityId: this.user.city,
        customerEmail: this.user.email,
        customerPhone: this.user.phone,
        // TODO: выпилить после выката редизайна, не забыть поправить vin-request-controller.ts
        partList: this.parts.map(part => ({
          ...part,
          partCondition: { id: part.partCondition },
        })),
      }).then(({ data }) => {
        this.$ym('vinrequest_submit');
        this.$ga('Shag3', 'Click48');
        this.requestResponse = data;
        this.complete = true;
      }).catch((e) => {
        if (get(e, 'response.data.error.errorCode', null) === 401) {
          this.isUniqueEmail = false;
        } else {
          console.log(e);
          console.log('Временная ошибка, пожалуйста, повторите запрос позднее');
        }
      }).finally(() => {
        this.loading = false;
      });
      return true;
    },
    toggleBodyEngine() {
      if (!this.isBodyEngineShown) {
        this.$ym('vinrequest_show_body_engine_open');
      }
      this.isBodyEngineShown = !this.isBodyEngineShown;
    },
    togglePartComment(index) {
      if (!this.parts[index].partCommentShow) {
        this.$ym('vinrequest_part_comment_open');
      }
      this.parts[index].partCommentShow = !this.parts[index].partCommentShow;
    },
    partQuantityInc(index) {
      this.parts[index].partQuantity = Number(this.parts[index].partQuantity) + 1;
    },
    partQuantityDec(index) {
      let newQuantity = Number(this.parts[index].partQuantity) - 1;
      if (newQuantity <= 1) {
        newQuantity = 1;
      }
      this.parts[index].partQuantity = newQuantity;
    },
    partQuantityVal(index, value) {
      let newQuantity = Number(value);
      if (!newQuantity || newQuantity <= 0) {
        newQuantity = 1;
      }
      this.parts[index].partQuantity = newQuantity;
    },
    partCommentText(index) {
      if (this.parts[index].partVendorCode && !this.parts[index].partCommentShow) {
        return 'Изменить комментарий';
      }

      return this.parts[index].partCommentShow
        ? 'Скрыть поле комментария'
        : 'Добавить комментарий';
    },
  },
};
</script>

<style lang="postcss">
  .requestToSpare {
    .pageHeading {
      .heading._h2 {
        padding-top: 0.5rem;
        font-size: 1rem;
        color: var(--color-main-lighten);
      }
    }

    &-content {
      display: block;
      padding: 0.5rem 0 4rem;

      .form {
        &-title {
          display: block;
          margin: 0;
          padding-bottom: 0.25rem;
          font-size: 0.875rem;
          font-weight: var(--font-weight-medium);
        }

        &-group {
          position: relative;
          display: flex;
          align-items: flex-start;
          margin: 0 -0.5rem;
          padding: 0.5rem 0;
        }

        &-item {
          position: relative;
          flex-shrink: 0;
          display: block;

          .multiselect__placeholder {
            color: var(--placeholder-color);
          }
        }

        .linkShowSwitcher {
          display: block;
          margin: 0;
          padding: 0;
          outline: none;
          border: none;
          background: none;
          cursor: pointer;
          margin-top: -0.5rem;
          padding-bottom: 0.5rem;
          font-size: 0.75rem;
        }
      }

      .input-field {
        &._textarea {
          height: 6rem;
          line-height: 1.4;
          resize: none;
        }
      }

      .buttonSend {
        width: 100%;
        @media only screen and ( min-width: 981px ) {
          position: relative;
          bottom: 0.625rem;
        }
      }

      .buttonMore {
        .svg.plus {
          width: 0.5rem;
          height: auto;
        }
      }

      .buttonTrash {
        display: inline-flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        margin-left: 1rem;
        height: var(--btn-height-regular);
        width: 1.5rem;
        border: none;
        outline: none;
        background: none;
        cursor: pointer;

        .svg {
          transition: all 0.3s;
          fill: var(--fill-light);
        }

        &:hover, &:active, &:focus {
          .svg {
            fill: var(--color-main);
          }
        }
      }
    }

    @media only screen and ( min-width: 981px ) {
      .form {
        &-group {
          &-car {
            display: flex;
            flex-wrap: wrap;
            width: 39.5rem;
          }
          &-vin {
            display: flex;
            width: calc(100% - 39.5rem);

            .vinExample {
              position: absolute;
              right: -1.5rem;
              top: 0.75rem;
              margin: 0.75rem 0.5rem 0 0;
            }
          }
          &-part {
            display: flex;
            flex-wrap: wrap;
            width: 40%;
            .buttonTrash {
              display: none;
            }
          }
          &-type {
            display: flex;
          }
          &-more {
            display: flex;
            margin-left: auto;
          }
        }

        &-item {
          padding: 0.5rem;

          &._bigger {
            flex-shrink: 1;
            width: 100%;
          }
          &._car {
            width: calc((100% - 10rem)/2);
          }
          &._car-year {
            width: 10rem;
          }

          &._part-name,
          &._comment {
            width: 100%;
          }

          &._counter {
            display: flex;
          }

          &._contact {
            width: 25%;
          }
          &._submit {
            margin-left: auto;
            width: 25%;
          }
        }
      }

      .input-message-error {
        position: absolute;
        top: -1em;
        left: 0.5rem;
        display: block;
      }

      .nativeSelect {
        display: none;
      }
    }

    @media ( min-width: 981px ) and ( max-width: 1200px ) {
      &-content {
        .buttonTrash {
          height: var(--btn-height-medium);
        }
      }

      .form {
        &-group {
          flex-wrap: wrap;
          padding-bottom: 2rem;
          max-width: 44rem;
          &-vin,
          &-car,
          &-part {
            width: 100%;
            .vinExample {
              position: static;
              margin: 1.125rem -1.25rem 0 0;
            }
          }
          &-more {
            width: auto;
          }
        }
        &-item {
          &._contact {
            width: 22rem;
            padding-bottom: 1rem;
          }
          &._submit {
            margin-left: 22rem;
            .buttonSend {
              width: 21rem;
            }
          }
        }
      }

      .inputNumber {
        height: var(--btn-height-medium);

        .input-field {
          height: 100%;
        }

        .button {
          height: 100%;
        }
      }
    }

    @media only screen and ( max-width: 980px ) {
      &-content {
        padding: 0;

        .buttonMore {
          width: 100%;
        }
      }
      .form {
        padding: 0 1.25rem;
        background-color: var(--bg-lightest);
        &-title {
          padding-top: 1.25rem;
          font-size: 1rem;
        }
        &-group {
          flex-direction: column;
          align-items: stretch;
          margin: 0;
          padding-bottom: 1rem;
          border-bottom: 1px solid var(--border-color-main);
          &:last-of-type {
            padding-bottom: 3rem;
            border-bottom: none;
          }
        }
        &-item {
          padding: 0.875rem 0;

          &._part-name {
            .wrapper {
              display: flex;
              align-items: center;

              .inputPartName {
                width: 100%;
              }

              .buttonTrash {
                flex-shrink: 0;
                margin: 0 0 0 0.75rem;
                padding: 0;
                width: 2.5rem;
                .svg {
                  width: 2.5rem;
                  height: auto;
                }
              }
            }
          }

          &._counter {
            .buttonTrash {
              display: none;
            }
          }
          &._car-year {
           .input {
             display: none;
           }
          }
        }

        .linkShowSwitcher {
          font-size: 1rem;
        }
      }

      .input-message-error {
        display: block;
        padding: 0 0 0.25rem;
      }
    }
  }

</style>
